//////////////////////////////////////////////////////////////////////////////////////////
////                                                                                  ////
////                                 Global Variables                                 ////
////                                                                                  ////
//////////////////////////////////////////////////////////////////////////////////////////
extern int MagicNumber=10001;
extern double minLotSize=0.01;
extern int Step=10;

int Slippage=3;
double MyPoint=Point;

///////////////////////////////////////////////////////////////////////////////////////////
////                                                                                   ////
////                                   Main Function                                   ////
////                                                                                   ////
///////////////////////////////////////////////////////////////////////////////////////////
int start()
{ 
  if(Digits==3 || Digits==5)
  MyPoint=Point*10;
  
  if(activeOrders()==0 && pendingOrders()>0)
  closeAllPendingOrders();
  
  if(OrdersTotal()==0)
  {
    if(MathRand()%2==0)
    openBuy();
    else
    openSell();
  }
  
  if(activeOrders()>0 && pendingOrders()==0)
  {
    modifyStopLimits();
    
    // pending order function need to be fixed.
    Print("pendingOrderType(): ", pendingOrderType());
    
    if(pendingOrderType()==OP_BUYSTOP)
    {
      if(OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(getLots(), 2),recoveryLevel(),Slippage,0,0,"Hedging&Martingale",MagicNumber,0,Blue))
      return true;
    }
    if(pendingOrderType()==OP_SELLSTOP)
    {
      if(OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(getLots(), 2),recoveryLevel(),Slippage,0,0,"Hedging&Martingale",MagicNumber,0,Red))
      return true;
    }
  }
  return true;
}

//////////////////////////////////////////////////////////////////////////////////////////
////                                                                                  ////
////                                 Custom Functions                                 ////
////                                                                                  ////
//////////////////////////////////////////////////////////////////////////////////////////
int openSell()
{
  if(OrderSend(Symbol(),OP_SELL,minLotSize,Bid,Slippage,0,0,"Hedging&Martingale",MagicNumber,0,Red))
  return true;
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int openBuy()
{
  if(OrderSend(Symbol(),OP_BUY,minLotSize,Ask,Slippage,0,0,"Hedging&Martingale",MagicNumber,0,Blue))
  return true;
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int modifyStopLimits()
{
  double selectedOOP=0;
  double greenLevel=greenLevel();
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    selectedOOP=OrderOpenPrice();
    
    if(selectedOOP>greenLevel)
    {
      if(OrderType()==OP_BUY)
      {
        if(OrderStopLoss()!=greenLevel-(Ask-Bid))
        {
          if(OrderModify(OrderTicket(), selectedOOP, greenLevel-(Ask-Bid), 0, 0, Red))
          continue;
        }
      }
      
      if(OrderType()==OP_SELL)
      {
        if(OrderTakeProfit()!=greenLevel)
        {
          if(OrderModify(OrderTicket(), selectedOOP, 0, greenLevel, 0, Red))
          continue;
        }
      }
    }
    if(selectedOOP<greenLevel)
    {
      if(OrderType()==OP_BUY)
      {
        if(OrderTakeProfit()!=greenLevel)
        {
          if(OrderModify(OrderTicket(), selectedOOP, 0, greenLevel, 0, Red))
          continue;
        }
      }
      if(OrderType()==OP_SELL)
      {
        if(OrderStopLoss()!=greenLevel+(Ask-Bid))
        {
          if(OrderModify(OrderTicket(), selectedOOP, greenLevel+(Ask-Bid), 0, 0, Red))
          continue;
        }
      }
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double maxOrder()
{
  double maxLot=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUY || OrderType()==OP_SELL)
      {
        maxLot=MathMax(maxLot, OrderLots());
      }
    }
  }
  return maxLot;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double greenLevel()
{
  double greenLimit=0;
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderLots()==maxOrder())
      {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        {
          if(OrderType()==OP_BUY)
          greenLimit=OrderOpenPrice()+Step*MyPoint;
        }
      }
    }
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderLots()==maxOrder())
      {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        {
          if(OrderType()==OP_SELL)
          greenLimit=OrderOpenPrice()-Step*MyPoint;
        }
      }
    }
  }
  return greenLimit;
}

//--------------------------------------------------------------------------------------------------------------------
double maxOpenPrice()
{
  double maxOPP;
  if(OrdersTotal()>0)
  {
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      maxOPP=OrderOpenPrice();
      for(int i=OrdersTotal()-1; i>=0; i--)
      {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        {
          if(OrderType()==OP_BUY || OrderType()==OP_SELL)
          {
            maxOPP=MathMax(maxOPP, OrderOpenPrice());
          }
        }
      }
    }
  }
  return maxOPP;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double minOpenPrice()
{
  double minOPP;
  if(OrdersTotal()>0)
  {
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      minOPP=OrderOpenPrice();
      for(int i=OrdersTotal()-1; i>=0; i--)
      {
        if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        {
          if(OrderType()==OP_BUY || OrderType()==OP_SELL)
          {
            minOPP=MathMin(minOPP, OrderOpenPrice());
          }
        }
      }
    }
  }
  return minOPP;
}

//----------------------------------------------------------------------------------------------------------------------------------------
double recoveryLevel()
{
  if(activeOrders()==1)
  {
    for(int i=OrdersTotal()-1; i>=0; i--)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if(OrderType()==OP_BUY)
        return minOpenPrice()-Step*MyPoint;
        if(OrderType()==OP_SELL)
        return maxOpenPrice()+Step*MyPoint;
      }
    }
  }
  
  if(activeOrders()>1)
  {
    if(greenLevel()>maxOpenPrice())
    {
      return minOpenPrice()-Step*MyPoint;
    }
    
    if(greenLevel()<minOpenPrice())
    {
      return maxOpenPrice()+Step*MyPoint;
    }
  }
  return true;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int activeOrders()
{
  int activeOrdersTotal=0;
  
  if(OrdersTotal()>0)
  {
    for(int i=OrdersTotal()-1; i>=0; i--)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if(OrderType()==OP_BUY || OrderType()==OP_SELL)
        activeOrdersTotal++;
      }
    }
  }
  return activeOrdersTotal;
}

//----------------------------------------------------------------------------------------------------------------------------------------
int pendingOrders()
{
  int pendingOrdersTotal=0;
  
  if(OrdersTotal()>0)
  {
    for(int i=OrdersTotal()-1; i>=0; i--)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP)
        pendingOrdersTotal++;
      }
    }
  }
  return pendingOrdersTotal;
}

//--------------------------------------------------------------------------------------------------------------------
int pendingOrderType()
{
  int pendingOrderType;
  
  if(activeOrders()==1)
  {
    for(int i=OrdersTotal()-1; i>=0; i--)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        if(OrderType()==OP_BUY)
        pendingOrderType=OP_SELLSTOP;
        if(OrderType()==OP_SELL)
        pendingOrderType=OP_BUYSTOP;
      }
    }
  }
  
  if(activeOrders()>1)
  {
    double maxOpenPrice=maxOpenPrice();
    double minOpenPrice=minOpenPrice();
    double selectedOOP=0;
    int selectedOType=0;
    
    if(recoveryLevel()>maxOpenPrice())
    {
      for(int j=OrdersTotal()-1; j>=0; j--)
      {
        if(OrderSelect(j, SELECT_BY_POS, MODE_TRADES))
        {
          selectedOOP=OrderOpenPrice();
          selectedOType=OrderType();
          if(selectedOOP==maxOpenPrice)
          {
            if(selectedOType==OP_BUY)
            pendingOrderType=OP_BUYSTOP;
            if(selectedOType==OP_SELL)
            pendingOrderType=OP_SELLSTOP;
          }
        }
      }
    }
    if(recoveryLevel()<minOpenPrice())
    {
      for(int k=OrdersTotal()-1; k>=0; k--)
      {
        if(OrderSelect(k, SELECT_BY_POS, MODE_TRADES))
        {
          selectedOOP=OrderOpenPrice();
          selectedOType=OrderType();
          if(selectedOOP==minOpenPrice)
          {
            if(selectedOType==OP_BUY)
            pendingOrderType=OP_BUYSTOP;
            if(selectedOType==OP_SELL)
            pendingOrderType=OP_SELLSTOP;
          }
        }
      }
    }
  }
  return pendingOrderType;
}

//--------------------------------------------------------------------------------------------------------------------
double recoveryLevelgreenlevel()
{
  double recoveryLevelgreenlevel=0;
  
  if(recoveryLevel()>maxOpenPrice())
  recoveryLevelgreenlevel=recoveryLevel()+Step*MyPoint;
  
  if(recoveryLevel()<minOpenPrice())
  recoveryLevelgreenlevel=recoveryLevel()-Step*MyPoint;
  
  return recoveryLevelgreenlevel;
}
//--------------------------------------------------------------------------------------------------------------------
double getLots()
{
  double recoveryLevel=recoveryLevel();
  double maxOpenPrice=maxOpenPrice();
  double minOpenPrice=minOpenPrice();
  double recoveryLevelgreenlevel=recoveryLevelgreenlevel();
  int activeOrders=activeOrders();
  double buyGains=0;
  double sellGains=0;
  double totalBuyGains=0;
  double totalSellGains=0;
  double requiredLotSize=0;
  
  // no opened order, open more orders.
  if(activeOrders==0)
  {
    requiredLotSize=minLotSize;
  }
  
  // there is opened orders, check how much do you need.
  if(activeOrders>0)
  {
    // calculate all buy orders gaines(active only)
    for(int i=OrdersTotal()-1; i>=0; i--)
    {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      {
        double selectedOOP=OrderOpenPrice();
        double selectedOType=OrderType();
        double selectedOLots=OrderLots();
        
        if(selectedOType==OP_BUY)
        {
          buyGains=((MathAbs(selectedOOP-recoveryLevelgreenlevel)+MathAbs(Ask-Bid))*10000)*(selectedOLots*10);
          totalBuyGains=totalBuyGains+buyGains;
        }
        if(selectedOType==OP_SELL)
        {
          sellGains=((MathAbs(selectedOOP-recoveryLevelgreenlevel)+MathAbs(Ask-Bid))*10000)*(selectedOLots*10);
          totalSellGains=totalSellGains+sellGains;
        }
      }
    }
    requiredLotSize=((MathAbs(totalBuyGains-totalSellGains))+(minLotSize*100))/100;
  }
  return requiredLotSize;
}

//--------------------------------------------------------------------------------------------------------------------
int closeAllPendingOrders()
{
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP)
      {
        if(OrderDelete(OrderTicket()))
        return true;
      }
    }
  }
  
  return true;
}